
%define Werror_cflags %nil

%define _disable_ld_no_undefined 1

%define with_hardware 	1
%define enable_egl	1
%define enable_wayland	1

%define opengl_ver 3.0

%define makedepend		%{_bindir}/gccmakedep

%define d3dname		d3d
%define eglname		mesaegl
%define glname		mesagl
%define glwname		mesaglw
%define glesv1name	mesaglesv1
%define glesv2name	mesaglesv2
%define openvgname	mesaopenvg
%define glapiname	glapi
%define gbmname		gbm
%define waylandeglname	wayland-egl
%define xaname		xatracker

%define d3dmajor		1
%define eglmajor		1
%define glmajor			1
%define glwmajor		1
%define glesv1major		1
%define glesv2major		2
%define openvgmajor		1
%define glapimajor		0
%define gbmmajor		1
%define waylandeglmajor		1
%define osmesamajor		8
%define xamajor			2

%define libd3dname		%mklibname %{d3dname} %{d3dmajor}
%define libeglname              %mklibname %{eglname} %{eglmajor}
%define libglname		%mklibname %{glname} %{glmajor}
%define libglwname		%mklibname %{glwname} %{glwmajor}
%define libglesv1name		%mklibname %{glesv1name}_ %{glesv1major}
%define libglesv2name		%mklibname %{glesv2name}_ %{glesv2major}
%define libopenvgname		%mklibname %{openvgname} %{openvgmajor}
%define libglapiname		%mklibname %{glapiname} %{glapimajor}
%define libgbmname		%mklibname %{gbmname} %{gbmmajor}
%define libwaylandeglname	%mklibname %{waylandeglname} %{waylandeglmajor}
%define libosmesaname		%mklibname osmesa %{osmesamajor}
%define libxaname		%mklibname %{xaname} %{xamajor}

%define dridrivers		%mklibname dri-drivers

%define osmesadevel		%mklibname osmesa -d

# Architecture-independent Virtual provides:
%define libd3dname_virt		lib%{d3dname}
%define libeglname_virt		lib%{eglname}
%define libglname_virt		lib%{glname}
%define libglwname_virt		lib%{glwname}
%define libglesv1name_virt	lib%{glesv1name}
%define libglesv2name_virt	lib%{glesv2name}
%define libopenvgname_virt	lib%{openvgname}
%define libglapiname_virt       lib%{glapiname}
%define libgbmname_virt       	lib%{gbmname}
%define libwaylandeglname_virt	lib%{waylandeglname}
%define libxaname_virt		lib%{xaname}

%define oldlibglname		%mklibname MesaGL 1

%define mesasrcdir		%{_prefix}/src/Mesa/
%define driver_dir		%{_libdir}/dri

%define	dri_drivers_i386	"i915,i965,nouveau,r200,radeon,swrast"
%define	dri_drivers_x86_64	%{dri_drivers_i386}
%define	dri_drivers_ppc		"r200,radeon,swrast"
%define	dri_drivers_ppc64	""
%define	dri_drivers_ia64	"i915,i965,mga,r200,radeon,swrast"
%define	dri_drivers_alpha	"r200,radeon,swrast"
%define	dri_drivers_sparc	"ffb,radeon,swrast"
%define dri_drivers_mipsel	"r200,radeon,swrast"
%define dri_drivers_arm		"nouveau,r200,radeon,swrast"
%define	dri_drivers		%{expand:%{dri_drivers_%{_arch}}}

Name:		mesa
Version: 	11.2.2
Release: 	%mkrel 1
Summary: OpenGL %{opengl_ver} compatible 3D graphics library
Group:	System/Libraries
URL:		http://www.mesa3d.org
Source0:	mesa-%{version}.tar.xz
Source3:	make-git-snapshot.sh
Patch201:	0201-revert-fix-glxinitializevisualconfigfromtags-handling.patch
Patch202:	mesa-dri2glx-fix.patch
License:	MIT
Provides:	Mesa = %{version}-%release
Obsoletes: Mesa < %{version}

Obsoletes:	%{_lib}dricore1 
Obsoletes:	%{_lib}dricore1-devel
Obsoletes:	%{_lib}llvmradeon9.2.0

BuildRequires: %{_lib}nettle-devel
BuildRequires: %{_lib}omxil-bellagio-devel
BuildRequires: %{_lib}talloc-devel
BuildRequires: %{_lib}drm-devel
BuildRequires: %{_lib}elfutils-devel
BuildRequires: %{_lib}expat1-devel
BuildRequires: %{_lib}udev0-devel
BuildRequires: %{_lib}vdpau-devel
BuildRequires: %{_lib}wayland-devel
BuildRequires: %{_lib}x11-devel
BuildRequires: %{_lib}xdamage-devel
BuildRequires: %{_lib}xext-devel
BuildRequires: %{_lib}xfixes-devel
BuildRequires: %{_lib}xxf86vm-devel
BuildRequires: %{_lib}va-devel
BuildRequires: libxcb-devel
BuildRequires: llvm-devel
BuildRequires: gccmakedep
BuildRequires: x11-proto-devel
BuildRequires: libxml2-python
BuildRequires: makedepend
BuildRequires: bison
BuildRequires: flex
BuildRequires: python-mako
%if %{enable_wayland}
BuildRequires:  %{_lib}wayland-devel
%endif

Obsoletes: %{_lib}dri-drivers < %version
Obsoletes: %{_lib}gbm1 < %version
Obsoletes: %{_lib}glapi0 < %version
Obsoletes: %{_lib}mesaegl1  < %version
Obsoletes: %{_lib}mesagl1 < %version 
Obsoletes: %{_lib}mesaglesv1_1  < %version
Obsoletes: %{_lib}mesaglesv2_2  < %version
Obsoletes: %{_lib}mesaopenvg1  < %version
Obsoletes: %{_lib}osmesa8 < %version
Obsoletes: %{_lib}vdpau-driver < %version 
Obsoletes: %{_lib}wayland-egl1 < %version 
Obsoletes: %{_lib}xatracker2  < %version
Obsoletes: mesa < %version
Obsoletes: mesagl < %{version}


Provides: %{_lib}dri-drivers = %version-%release
Provides: %{_lib}gbm1 = %version-%release
Provides: %{_lib}glapi0 = %version-%release
Provides: %{_lib}mesaegl1 = %version-%release
Provides: %{_lib}mesagl1 = %version-%release
Provides: %{_lib}mesaglesv1_1 = %version-%release 
Provides: %{_lib}mesaglesv2_2  = %version-%release
Provides: %{_lib}mesaopenvg1 = %version-%release 
Provides: %{_lib}osmesa8  = %version-%release
Provides: %{_lib}vdpau-driver = %version-%release 
Provides: %{_lib}wayland-egl1  = %version-%release
Provides: %{_lib}xatracker2  = %version-%release
Provides: mesa = %version-%release
Provides: mesagl = %version-%release
Provides: libmesagl = %version-%release

%description
OpenGL compatible 3D graphics library


%package	devel
Summary:	Development files for Mesa
Group:		Development/Libraries
Provides:	Mesa-common-devel = %{version}-%{release}
Obsoletes:	Mesa-common-devel < %{version}

Obsoletes: mesagl-devel < %{version}
Obsoletes: mesa-common-devel < %{version}
Obsoletes: %{_lib}gbm1-devel < %{version}
Obsoletes: %{_lib}glapi0-devel < %{version}
Obsoletes: %{_lib}mesaegl1-devel < %{version}
Obsoletes: %{_lib}mesagl1-devel < %{version}
Obsoletes: %{_lib}mesaglesv1_1-devel < %{version}
Obsoletes: %{_lib}mesaglesv2_2-devel < %{version}
Obsoletes: %{_lib}mesaopenvg1-devel < %{version}
Obsoletes: %{_lib}osmesa-devel < %{version}
Obsoletes: %{_lib}wayland-egl1-devel < %{version}
Obsoletes: %{_lib}xatracker2-devel  < %{version}

Provides: mesagl-devel = %{version}-%{release}
Provides: mesa-common-devel = %{version}-%{release}
Provides: %{_lib}gbm1-devel = %{version}-%{release}
Provides: %{_lib}glapi0-devel = %{version}-%{release}
Provides: %{_lib}mesaegl1-devel = %{version}-%{release}
Provides: %{_lib}mesagl1-devel = %{version}-%{release}
Provides: %{_lib}mesaglesv1_1-devel = %{version}-%{release}
Provides: %{_lib}mesaglesv2_2-devel = %{version}-%{release}
Provides: %{_lib}mesaopenvg1-devel = %{version}-%{release}
Provides: %{_lib}osmesa-devel = %{version}-%{release}
Provides: %{_lib}wayland-egl1-devel = %{version}-%{release}
Provides: %{_lib}xatracker2-devel = %{version}-%{release} 
Provides: libmesagl-devel = %{version}-%{release}
Provides: GL-devel = %{version}-%{release}
#------------------------------------------------------------------------------

%description devel
Development files for Mesa


%prep
%setup -q -n mesa-%{version}
%patch201 -p1
%patch202 -p1

all=$(ls)
mkdir -p build-osmesa
cp -al $all build-osmesa

%build
autoreconf -vfi

# for bin/test-driver:
automake --add-missing

export LDFLAGS="-L%{_libdir}/llvm"

%define _smp_mflags -j4

%configure2_5x	--enable-dri \
		--enable-glx \
		--enable-glx-tls \
		--with-dri-driverdir=%{driver_dir} \
		--with-dri-drivers="%{dri_drivers}" \
		--enable-va \
		--enable-nine \
		--enable-egl \
%if %{enable_wayland}
		--with-egl-platforms=x11,wayland,drm \
		--enable-gbm \
		--enable-shared-glapi \
%endif
		--enable-gles1 \
		--enable-gles2 \
		--enable-gallium-egl \
		--disable-xvmc \
		--enable-vdpau \
%if %{with_hardware}
		--with-gallium-drivers=r300,r600,radeonsi,nouveau,svga,swrast \
		--enable-gallium-llvm \
		--enable-xa \
%else
		--disable-gallium-llvm \
		--with-gallium-drivers=swrast \
%endif
		--enable-texture-float  \
		# end of configure options



pushd build-osmesa
autoreconf -vfi
%configure2_5x \
		--enable-osmesa \
		--disable-dri \
		--disable-glx \
		--disable-egl \
		--enable-shared-glapi \
		--without-gallium-drivers
popd

%make
%make -C build-osmesa || ( %make -C build-osmesa/src/mesa/program libprogram.la && %make -C build-osmesa )

%install
%makeinstall_std -C build-osmesa
%makeinstall_std

mkdir -p $RPM_BUILD_ROOT%{_libdir}/mesa
pushd $RPM_BUILD_ROOT%{_libdir}/mesa
for l in ../libGL.so.*; do cp -a $l .; done
popd

%ifarch %{x86_64}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/dri
%endif

rm -f %{buildroot}%{_libdir}/vdpau/libvdpau_*.so

find %{buildroot} -name '*.la' -exec rm {} \;

[ -e %{buildroot}%{_libdir}/dri/swrastg_dri.so ] && mv %{buildroot}%{_libdir}/dri/swrast{g,}_dri.so

#------------------------------------------------------------------------------

%files
%defattr(-,root,root)
%doc docs/COPYING
%config(noreplace) %{_sysconfdir}/drirc

%dir %{_libdir}/dri
%{_libdir}/dri/*_dri.so
%{_libdir}/dri/gallium_drv_video.so

%{_libdir}/libGL.so.*
%dir %{_libdir}/mesa
%{_libdir}/mesa/libGL.so.%{glmajor}*

%if %{enable_egl}
%{_libdir}/libEGL.so.%{eglmajor}*
%if !%{enable_wayland}
%{_libdir}/egl/st_GL.so
%endif
%endif

%{_libdir}/libOSMesa.so.%{osmesamajor}*
%{_libdir}/libglapi.so.%{glapimajor}*
%{_libdir}/libGLESv1_CM.so.%{glesv1major}*
%{_libdir}/libGLESv2.so.%{glesv2major}*

%if %{enable_wayland}
%{_libdir}/libgbm.so.%{gbmmajor}
%{_libdir}/libgbm.so.%{gbmmajor}.*
%{_libdir}/libwayland-egl.so.%{waylandeglmajor}
%{_libdir}/libwayland-egl.so.%{waylandeglmajor}.*
%endif

%{_libdir}/vdpau/libvdpau_nouveau.so.*
%{_libdir}/vdpau/libvdpau_r600.so.*
%{_libdir}/vdpau/libvdpau_radeonsi.so.*
%{_libdir}/vdpau/libvdpau_r300.so.*
%{_libdir}/libxatracker.so.%{xamajor}*
%{_libdir}/d3d/*.so.*

#---------------------------------------------------

%files devel
%defattr(-,root,root)
%doc docs/COPYING
%dir %{_includedir}/GL
%{_includedir}/GL/gl.h
%{_includedir}/GL/glcorearb.h
%{_includedir}/GL/glext.h
%{_includedir}/GL/gl_mangle.h
%{_includedir}/GL/wglext.h
%{_includedir}/GL/glx.h
%{_includedir}/GL/glxext.h
%{_includedir}/GL/glx_mangle.h
%{_libdir}/libGL.so
%{_libdir}/pkgconfig/gl.pc
%{_libdir}/pkgconfig/dri.pc


%dir %{_includedir}/GL/internal
%{_includedir}/GL/internal/dri_interface.h

%if %{enable_egl}
%{_includedir}/EGL
%{_includedir}/KHR
%{_libdir}/libEGL.so
%{_libdir}/pkgconfig/egl.pc
%endif

%dir %{_includedir}/GL
%{_includedir}/GL/osmesa.h
%{_libdir}/libOSMesa.so
%{_libdir}/pkgconfig/osmesa.pc

%{_libdir}/libglapi.so

%{_includedir}/GLES
%{_libdir}/libGLESv1_CM.so
%{_libdir}/pkgconfig/glesv1_cm.pc

%{_includedir}/GLES2
%{_includedir}/GLES3
%{_libdir}/libGLESv2.so
%{_libdir}/pkgconfig/glesv2.pc

%if %{enable_wayland}
%{_includedir}/gbm.h
%{_libdir}/libgbm.so
%{_libdir}/pkgconfig/gbm.pc

%{_libdir}/libwayland-egl.so
%{_libdir}/pkgconfig/wayland-egl.pc
%endif

%{_libdir}/libxatracker.so
%{_includedir}/xa_tracker.h
%{_includedir}/xa_composite.h
%{_includedir}/xa_context.h
%{_libdir}/pkgconfig/xatracker.pc
%{_includedir}/d3dadapter
%{_libdir}/d3d/*.so
%{_libdir}/pkgconfig/d3d.pc


%changelog
* Mon May 09 2016 bb <bb> 11.2.2-1pclos2016
- update

* Sat Apr 30 2016 bb <bb> 11.2.1-4pclos2016
- rebuild for new libnettle

* Wed Apr 20 2016 bb <bb> 11.2.1-3pclos2016
- drop cflag performance opts

* Sun Apr 17 2016 bb <bb> 11.2.1-2pclos2016
- add cflag performance opts

* Sun Apr 17 2016 bb <bb> 11.2.1-1pclos2016
- update

* Mon Apr 04 2016 bb <bb> 11.2.0-1pclos2016
- update

* Thu Feb 11 2016 bb <bb> 11.1.2-1pclos2016
- update

* Wed Jan 13 2016 bb <bb> 11.1.1-1pclos2016
- update

* Wed Jan 06 2016 bb <bb> 11.1.0-3pclos2016
- rebuild with fixed llvm

* Wed Jan 06 2016 bb <bb> 11.1.0-2pclos2016
- rebuild for new llvm


